## lxml 4.2.1

=== debian/changelog ===
lxml (4.2.1-1ubuntu0.6) bionic-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - debian/patches/CVE-2021-43818-*.patch: prevent "@import"
      from re-occurring in the CSS after replacements and remove
      SVG image data URLs since they can embed script content in
      src/lxml/html/clean.py, src/html/tests/test_clean.py.
    - CVE-2021-43818

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 04 Jan 2022 10:51:53 -0300

lxml (4.2.1-1ubuntu0.4) bionic-security; urgency=medium

  * SECURITY UPDATE: incorrect formaction attribute input sanitization
    - debian/patches/CVE-2021-28957.patch: add HTML-5 formaction attribute
      to defs.link_attrs in src/lxml/html/defs.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2021-28957

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 29 Mar 2021 12:04:43 -0400

lxml (4.2.1-1ubuntu0.3) bionic-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - debian/patches/CVE-2020-27783-part2.patch:
      This adds the missing part reported from upstream
      Prevent combinations of <noscript> and <style> to sneak
      JS through the HTML cleaner in src/lxml/html/clean.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2020-27783
  * Adding --with-cython to debian/rules in order to it build compile the .py
    files changed and regenerate the .c files to the binaries.

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 10 Dec 2020 14:18:33 -0300

lxml (4.2.1-1ubuntu0.2) bionic-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - Prevent combinations of <noscript> and <style> to sneak
      JS through the HTML cleaner in src/lxml/html/clean.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2020-27783

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 08 Dec 2020 13:53:38 -0300

lxml (4.2.1-1ubuntu0.1) bionic-security; urgency=medium

  * SECURITY UPDATE: XSS attacks
    - debian/patches/CVE-2018-19787.patch:
      Make the cleaner remove javascript URLs
      that use espacing in in src/lxml/html/clean.py,
      src/lxml/html/tests/test_clean.txt.
    - CVE-2018-19787

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Fri, 07 Dec 2018 09:50:09 -0300

lxml (4.2.1-1) unstable; urgency=medium

  * New upstream version 4.2.1.

 -- Matthias Klose <doko@debian.org>  Mon, 02 Apr 2018 11:36:32 +0200

lxml (4.2.0-1) unstable; urgency=medium

  * New upstream version 4.2.0.

 -- Matthias Klose <doko@debian.org>  Fri, 16 Mar 2018 14:41:33 +0100

=== debian/control ===
Source: lxml
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9),
  dh-python,
  python-all-dev (>= 2.6.6-1~), python-all-dbg,
  python3-all-dev (>= 3.3.3), python3-all-dbg,
  python-pyrex (>= 0.9.4.1),
  libxml2-dev, libxslt1-dev, zlib1g-dev,
  python-setuptools, python3-setuptools (>= 0.6.29),
  python-bs4, python3-bs4,
  python-html5lib, python3-html5lib,
  cython, cython-dbg, cython3, cython3-dbg,
X-Python-Version: all
Standards-Version: 4.1.3
Homepage: http://lxml.de/

Package: python-lxml
Architecture: any
Multi-Arch: same
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Recommends: python-bs4, python-html5lib
Suggests: python-lxml-dbg, python-lxml-doc
Description: pythonic binding for the libxml2 and libxslt libraries
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from existing Python bindings. Its aim:
 .
   * Pythonic API.
   * Documented.
   * Use Python unicode strings in API.
   * Safe (no segfaults).
   * No manual memory management!
 .
 lxml aims to provide a Pythonic API by following as much as possible
 the ElementTree API, trying to avoid inventing too many new APIs,
 or the user's having to learn new things -- XML is complicated enough.

Package: python-lxml-dbg
Priority: optional
Section: debug
Architecture: any
Multi-Arch: same
Depends: python-lxml (= ${binary:Version}), python-dbg, ${shlibs:Depends}, ${misc:Depends}
Description: pythonic binding for the libxml2 and libxslt libraries (debug extension)
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from existing Python bindings.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python3-lxml
Architecture: any
Multi-Arch: same
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Recommends: python3-bs4, python3-html5lib
Suggests: python3-lxml-dbg, python-lxml-doc
Provides: ${python3:Provides}
Description: pythonic binding for the libxml2 and libxslt libraries
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from existing Python bindings. Its aim:
 .
   * Pythonic API.
   * Documented.
   * Use Python unicode strings in API.
   * Safe (no segfaults).
   * No manual memory management!
 .
 lxml aims to provide a Pythonic API by following as much as possible
 the ElementTree API, trying to avoid inventing too many new APIs,
 or the user's having to learn new things -- XML is complicated enough.

Package: python3-lxml-dbg
Priority: optional
Section: debug
Architecture: any
Multi-Arch: same
Depends: python3-lxml (= ${binary:Version}), python3-dbg, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: pythonic binding for the libxml2 and libxslt libraries (debug extension)
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from existing Python bindings.
 .
 This package contains the extension built for the Python3 debug interpreter.

Package: python-lxml-doc
Priority: optional
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: python-lxml
Description: pythonic binding for the libxml2 and libxslt libraries (documentation)
 lxml is a new Python binding for libxml2 and libxslt, completely
 independent from these existing Python bindings.
 .
 This package contains the html documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PYVERS	:= $(shell pyversions -vs)
PYVER	:= $(shell pyversions -vd)

PY3VERS	:= $(shell py3versions -vs)
PY3VER	:= $(shell py3versions -vd)

UPSTREAMVER := $(subst lxml-,,$(notdir $(CURDIR)))

include /usr/share/python3/python.mk

prebuild: prebuild-stamp
prebuild-stamp: src/lxml/etree.pyx src/lxml/objectify.pyx
#	cython src/lxml/etree.pyx src/lxml/objectify.pyx
	touch $@

build-arch: build
build-indep: build
build: build-stamp build3-stamp
build-stamp: $(PYVERS:%=build-python%) $(PYVERS:%=dbg-build-python%)
	touch $@
build-python%: prebuild
	python$* setup.py build --with-cython
	touch $@
dbg-build-python%: prebuild
	python$*-dbg setup.py build --with-cython
	touch $@

build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%)
	touch $@
build3-python%: prebuild
	python$* setup.py build --with-cython
	touch $@
dbg-build3-python%: prebuild
	python$*-dbg setup.py build --with-cython
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build*-stamp build*-python* dbg-build*-python* prebuild-stamp
	rm -rf build dist __pycache__
#	rm -f src/lxml/lxml.etree_api.h src/lxml/lxml.etree.c \
#	      src/lxml/lxml.etree.h src/lxml/lxml.objectify.c

	-find -name '*.py[co]' | xargs rm -f
	rm -rf [23].[0-9]
	rm -f src/lxml/lxml-version.h
	dh_clean 

install: build install-prereq $(PYVERS:%=install-python%) $(PYVERS:%=dbg-install-python%) $(PY3VERS:%=install3-python%) $(PY3VERS:%=dbg-install3-python%)
	-find debian -name '*.py[co]' | xargs rm -f
	-find debian -name __pycache__ | xargs rm -rf
	rm -rf debian/python*-lxml/usr/lib/python

install-prereq:
	dh_testdir
	dh_testroot
	dh_prep

install-python%:
	mkdir -p debian/python-lxml/usr/bin
	mkdir -p debian/python-lxml/$(call py_libdir, $*)
	python$* setup.py install \
		--root=$(CURDIR)/debian/python-lxml --install-layout=deb

dbg-install-python%:
	mkdir -p debian/python-lxml/usr/bin
	mkdir -p debian/python-lxml-dbg/$(call py_libdir, $*)
	python$*-dbg setup.py install \
		--root=$(CURDIR)/debian/python-lxml-dbg --install-layout=deb
	find debian/python-*-dbg ! -type d ! -name '*.so' | xargs rm -f
	find debian/python-*-dbg -depth -empty -exec rmdir {} \;

install3-python%:
	mkdir -p debian/python3-lxml/usr/bin
	mkdir -p debian/python3-lxml/$(call py_libdir, $*)
	python$* setup.py install \
		--root=$(CURDIR)/debian/python3-lxml --install-layout=deb

dbg-install3-python%:
	mkdir -p debian/python3-lxml/usr/bin
	mkdir -p debian/python3-lxml-dbg/$(call py_libdir, $*)
	python$*-dbg setup.py install \
		--root=$(CURDIR)/debian/python3-lxml-dbg --install-layout=deb
	find debian/python3-*-dbg ! -type d ! -name '*.so' | xargs rm -f
	find debian/python3-*-dbg -depth -empty -exec rmdir {} \;

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -i
	dh_installdocs -i
	mkdir -p debian/python-lxml-doc/usr/share/doc/python-lxml
	cp -r doc/html debian/python-lxml-doc/usr/share/doc/python-lxml/
	ln -sf ../python-lxml/html debian/python-lxml-doc/usr/share/doc/python-lxml-doc/html
	dh_installexamples -i samples/*
	dh_compress -i -X.xml -X.py \
	    -X.html -X.css -X.asc -X.png -Xapi-objects.txt
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a CHANGES.txt
	dh_installdocs -a CREDITS.txt README.rst TODO.txt
	dh_installexamples -a samples/*
	dh_python2 -a
	dh_python3 -a
	dh_strip -ppython-lxml --dbg-package=python-lxml-dbg
	rm -rf debian/python-lxml-dbg/usr/share/doc/python-lxml-dbg
	ln -s python-lxml debian/python-lxml-dbg/usr/share/doc/python-lxml-dbg
	dh_strip -ppython3-lxml --dbg-package=python3-lxml-dbg
	rm -rf debian/python3-lxml-dbg/usr/share/doc/python3-lxml-dbg
	ln -s python3-lxml debian/python3-lxml-dbg/usr/share/doc/python3-lxml-dbg
	dh_compress -a -X.xml -X.py \
	    -X.html -X.css -X.asc -X.png -Xapi-objects.txt
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## lxml 4.2.4

=== debian/changelog ===
lxml (4.2.4-1) unstable; urgency=medium

  * New upstream version 4.2.4.

 -- Matthias Klose <doko@debian.org>  Mon, 20 Aug 2018 14:59:17 +0200

lxml (4.2.3-1) unstable; urgency=medium

  * New upstream version 4.2.3.

 -- Matthias Klose <doko@debian.org>  Wed, 11 Jul 2018 14:43:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lxml
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9),
   dh-python,
   python-all-dev (>= 2.6.6-1~), python-all-dbg,
@@ -14,7 +13,7 @@
   python-html5lib, python3-html5lib,
   cython, cython-dbg, cython3, cython3-dbg,
 X-Python-Version: all
-Standards-Version: 4.1.3
+Standards-Version: 4.2.0
 Homepage: http://lxml.de/
 
 Package: python-lxml

## lxml 4.2.5

=== debian/changelog ===
lxml (4.2.5-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Nicholas D Steeves <nsteeves@gmail.com>  Wed, 28 Nov 2018 14:07:40 -0500

lxml (4.2.5-1) unstable; urgency=medium

  * New upstream version 4.2.5.

 -- Matthias Klose <doko@debian.org>  Mon, 17 Sep 2018 16:47:04 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
   python-html5lib, python3-html5lib,
   cython, cython-dbg, cython3, cython3-dbg,
 X-Python-Version: all
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: http://lxml.de/
 
 Package: python-lxml

## lxml 4.3.0

=== debian/changelog ===
lxml (4.3.0-1) unstable; urgency=medium

  * New upstream version 4.3.0.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Fri, 18 Jan 2019 10:04:35 +0100

## lxml 4.3.1

=== debian/changelog ===
lxml (4.3.1-1) unstable; urgency=medium

  * New upstream version 4.3.1.

 -- Matthias Klose <doko@debian.org>  Wed, 20 Feb 2019 16:27:45 +0100

## lxml 4.3.2

=== requirements.txt ===
Cython>=0.29.1

=== debian/changelog ===
lxml (4.3.2-1+deb10u4) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Cleaner: Prevent "@import" from re-occurring in the CSS after
    replacements, e.g. "@@importimport" (CVE-2021-43818) (Closes: #1001885)
  * Cleaner: Remove SVG image data URLs since they can embed script content
    (CVE-2021-43818) (Closes: #1001885)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 12 Jan 2022 17:58:11 +0100

lxml (4.3.2-1+deb10u3) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * CVE-2021-28957 (Closes: #985643)
    Due to missing input sanitization, XSS is possible for the HTML5
    formatcion attribute.

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 23 Mar 2021 19:03:02 +0100

lxml (4.3.2-1+deb10u2) buster-security; urgency=medium

  * Enable the test suite (non-fatal).
  * math-svg.patch: update expected results for the test suite.
  * Fix regression in Python 2 in the last part of CVE-2020-27783.
    Closes: #977387.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Fri, 18 Dec 2020 10:05:56 +0100

lxml (4.3.2-1+deb10u1) buster-security; urgency=medium

  * CVE-2020-27783
  * Backport a105ab8dc262ec6735977c25c13f0bdfcdec72a7 for similar issue
  * Pass --with-cython to make sure the C parts get actually rebuilt

 -- Moritz Mühlenhoff <jmm@debian.org>  Thu, 26 Nov 2020 19:32:59 +0100

lxml (4.3.2-1) unstable; urgency=medium

  * New upstream version.
    - Fix crash in 4.3.1 when appending a child subtree with certain text nodes.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Mar 2019 16:27:09 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
   python-html5lib, python3-html5lib,
   cython, cython-dbg, cython3, cython3-dbg,
 X-Python-Version: all
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: http://lxml.de/
 
 Package: python-lxml

## lxml 4.3.2.1

=== debian/changelog ===
lxml (4.3.2.1-1+eagle) unstable; urgency=medium

  * update

 -- Matthias Klose <doko@debian.org>  Thu, 21 Jan 2021 18:16:46 +0800

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 build-arch: build
 build-indep: build
 build: build-stamp build3-stamp
-build-stamp: $(PYVERS:%=build-python%) $(PYVERS:%=dbg-build-python%)
+build-stamp: $(PYVERS:%=build-python%) $(PYVERS:%=dbg-build-python%) $(PYVERS:%=check-python%)
 	touch $@
 build-python%: prebuild
 	python$* setup.py build --with-cython
@@ -31,7 +31,7 @@
 	python$*-dbg setup.py build --with-cython
 	touch $@
 
-build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%)
+build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%) $(PY3VERS:%=check-python%)
 	touch $@
 build3-python%: prebuild
 	python$* setup.py build --with-cython
@@ -40,10 +40,17 @@
 	python$*-dbg setup.py build --with-cython
 	touch $@
 
+check-python%:
+	python$* setup.py build_ext -i
+	-python$* test.py -vv
+	#python$*-dbg setup.py build_ext -i
+	#-python$*-dbg test.py -vv
+	touch $@
+
 clean:
 	dh_testdir
 	dh_testroot
-	rm -f build*-stamp build*-python* dbg-build*-python* prebuild-stamp
+	rm -f build*-stamp build*-python* dbg-build*-python* prebuild-stamp check-python*
 	rm -rf build dist __pycache__
 #	rm -f src/lxml/lxml.etree_api.h src/lxml/lxml.etree.c \
 #	      src/lxml/lxml.etree.h src/lxml/lxml.objectify.c

## lxml 4.3.3

=== debian/changelog ===
lxml (4.3.3-2) unstable; urgency=medium

  * python-lxml-doc: Recommend python3-lxml instead of python-lxml.

 -- Matthias Klose <doko@debian.org>  Wed, 22 May 2019 14:42:58 +0200

lxml (4.3.3-1) unstable; urgency=medium

  * New upstream version.
    - Fix leak of output buffer and unclosed files in
      ``_XSLTResultTree.write_output()``.

 -- Matthias Klose <doko@debian.org>  Wed, 10 Apr 2019 10:49:36 +0200

=== debian/control ===
--- 
+++ 
@@ -89,7 +89,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
-Recommends: python-lxml
+Recommends: python3-lxml
 Description: pythonic binding for the libxml2 and libxslt libraries (documentation)
  lxml is a new Python binding for libxml2 and libxslt, completely
  independent from these existing Python bindings.

## lxml 4.4.1

=== debian/changelog ===
lxml (4.4.1-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 15 Aug 2019 19:27:20 +0200

lxml (4.3.4-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 24 Jun 2019 13:18:04 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
   python-html5lib, python3-html5lib,
   cython, cython-dbg, cython3, cython3-dbg,
 X-Python-Version: all
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: http://lxml.de/
 
 Package: python-lxml

## lxml 4.4.2

=== Makefile ===
PYTHON?=python
PYTHON3?=python3
TESTFLAGS=-p -v
TESTOPTS=
SETUPFLAGS=
LXMLVERSION=$(shell cat version.txt)

PARALLEL=$(shell $(PYTHON) -c 'import sys; print("-j7" if sys.version_info >= (3, 5) else "")' )
PARALLEL3=$(shell $(PYTHON3) -c 'import sys; print("-j7" if sys.version_info >= (3, 5) else "")' )
PYTHON_WITH_CYTHON=$(shell $(PYTHON)  -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
PY3_WITH_CYTHON=$(shell $(PYTHON3) -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
CYTHON_WITH_COVERAGE=$(shell $(PYTHON) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
CYTHON3_WITH_COVERAGE=$(shell $(PYTHON3) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)

MANYLINUX_LIBXML2_VERSION=2.9.9
MANYLINUX_LIBXSLT_VERSION=1.1.33
MANYLINUX_IMAGE_X86_64=quay.io/pypa/manylinux1_x86_64
MANYLINUX_IMAGE_686=quay.io/pypa/manylinux1_i686

.PHONY: all inplace inplace3 rebuild-sdist sdist build require-cython wheel_manylinux wheel

all: inplace

# Build in-place
inplace:
	$(PYTHON) setup.py $(SETUPFLAGS) build_ext -i $(PYTHON_WITH_CYTHON) --warnings --with-coverage $(PARALLEL)

inplace3:
	$(PYTHON3) setup.py $(SETUPFLAGS) build_ext -i $(PY3_WITH_CYTHON) --warnings --with-coverage $(PARALLEL3)

rebuild-sdist: require-cython
	rm -f dist/lxml-$(LXMLVERSION).tar.gz
	find src -name '*.c' -exec rm -f {} \;
	$(MAKE) dist/lxml-$(LXMLVERSION).tar.gz

dist/lxml-$(LXMLVERSION).tar.gz:
	$(PYTHON) setup.py $(SETUPFLAGS) sdist $(PYTHON_WITH_CYTHON)

sdist: dist/lxml-$(LXMLVERSION).tar.gz

build:
	$(PYTHON) setup.py $(SETUPFLAGS) build $(PYTHON_WITH_CYTHON)

require-cython:
	@[ -n "$(PYTHON_WITH_CYTHON)" ] || { \
	    echo "NOTE: missing Cython - please use this command to install it: $(PYTHON) -m pip install Cython"; false; }

wheel_manylinux: wheel_manylinux64 wheel_manylinux32

wheel_manylinux32 wheel_manylinux64: dist/lxml-$(LXMLVERSION).tar.gz
	time docker run --rm -t \
		-v $(shell pwd):/io \
		-e CFLAGS="-O3 -g1 -march=core2 -pipe -fPIC -flto" \
		-e LDFLAGS="$(LDFLAGS) -flto" \
		-e LIBXML2_VERSION="$(MANYLINUX_LIBXML2_VERSION)" \
		-e LIBXSLT_VERSION="$(MANYLINUX_LIBXSLT_VERSION)" \
		-e WHEELHOUSE=wheelhouse_$(subst wheel_,,$@) \
		$(if $(patsubst %32,,$@),$(MANYLINUX_IMAGE_X86_64),$(MANYLINUX_IMAGE_686)) \
		bash /io/tools/manylinux/build-wheels.sh /io/$<

wheel:
	$(PYTHON) setup.py $(SETUPFLAGS) bdist_wheel $(PYTHON_WITH_CYTHON)

wheel_static:
	$(PYTHON) setup.py $(SETUPFLAGS) bdist_wheel $(PYTHON_WITH_CYTHON) --static-deps

test_build: build
	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)

test_inplace: inplace
	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS) $(CYTHON_WITH_COVERAGE)

test_inplace3: inplace3
	$(PYTHON3) test.py $(TESTFLAGS) $(TESTOPTS) $(CYTHON3_WITH_COVERAGE)

valgrind_test_inplace: inplace
	valgrind --tool=memcheck --leak-check=full --num-callers=30 --suppressions=valgrind-python.supp \
		$(PYTHON) test.py

gdb_test_inplace: inplace
	@echo "file $(PYTHON)\nrun test.py" > .gdb.command
	gdb -x .gdb.command -d src -d src/lxml

bench_inplace: inplace
	$(PYTHON) benchmark/bench_etree.py -i
	$(PYTHON) benchmark/bench_xpath.py -i
	$(PYTHON) benchmark/bench_xslt.py -i
	$(PYTHON) benchmark/bench_objectify.py -i

ftest_build: build
	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)

ftest_inplace: inplace
	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)

apihtml: inplace
	rm -fr doc/html/api
	@[ -x "`which epydoc`" ] \
		&& (cd src && echo "Generating API docs ..." && \
			PYTHONPATH=. epydoc -v --docformat "restructuredtext en" \
			-o ../doc/html/api --exclude='[.]html[.]tests|[.]_' \
			--exclude-introspect='[.]usedoctest' \
			--name "lxml API" --url / lxml/) \
		|| (echo "not generating epydoc API documentation")

website: inplace
	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON) doc/mkhtml.py doc/html . ${LXMLVERSION}

html: inplace website apihtml s5

s5:
	$(MAKE) -C doc/s5 slides

apipdf: inplace
	rm -fr doc/pdf
	mkdir -p doc/pdf
	@[ -x "`which epydoc`" ] \
		&& (cd src && echo "Generating API docs ..." && \
			PYTHONPATH=. epydoc -v --latex --docformat "restructuredtext en" \
			-o ../doc/pdf --exclude='([.]html)?[.]tests|[.]_' \
			--exclude-introspect='html[.]clean|[.]usedoctest' \
			--name "lxml API" --url / lxml/) \
		|| (echo "not generating epydoc API documentation")

pdf: apipdf
	$(PYTHON) doc/mklatex.py doc/pdf . ${LXMLVERSION}
	(cd doc/pdf && pdflatex lxmldoc.tex \
		    && pdflatex lxmldoc.tex \
		    && pdflatex lxmldoc.tex)
	@cp doc/pdf/lxmldoc.pdf doc/pdf/lxmldoc-${LXMLVERSION}.pdf
	@echo "PDF available as doc/pdf/lxmldoc-${LXMLVERSION}.pdf"

# Two pdflatex runs are needed to build the correct Table of contents.

test: test_inplace

test3: test_inplace3

valtest: valgrind_test_inplace

gdbtest: gdb_test_inplace

bench: bench_inplace

ftest: ftest_inplace

clean:
	find . \( -name '*.o' -o -name '*.so' -o -name '*.py[cod]' -o -name '*.dll' \) -exec rm -f {} \;
	rm -rf build

docclean:
	$(MAKE) -C doc/s5 clean
	rm -f doc/html/*.html
	rm -fr doc/html/api
	rm -fr doc/pdf

realclean: clean docclean
	find src -name '*.c' -exec rm -f {} \;
	rm -f TAGS
	$(PYTHON) setup.py clean -a --without-cython

=== debian/changelog ===
lxml (4.4.2-1) unstable; urgency=medium

  * New upstream version.
  * python-lxml-dbg: Depend on python2-dbg instead of python-dbg.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Jan 2020 13:55:11 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
   python-html5lib, python3-html5lib,
   cython, cython-dbg, cython3, cython3-dbg,
 X-Python-Version: all
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: http://lxml.de/
 
 Package: python-lxml
@@ -42,7 +42,7 @@
 Section: debug
 Architecture: any
 Multi-Arch: same
-Depends: python-lxml (= ${binary:Version}), python-dbg, ${shlibs:Depends}, ${misc:Depends}
+Depends: python-lxml (= ${binary:Version}), python2-dbg, ${shlibs:Depends}, ${misc:Depends}
 Description: pythonic binding for the libxml2 and libxslt libraries (debug extension)
  lxml is a new Python binding for libxml2 and libxslt, completely
  independent from existing Python bindings.

## lxml 4.5.0

=== Makefile ===
--- 
+++ 
@@ -3,17 +3,17 @@
 TESTFLAGS=-p -v
 TESTOPTS=
 SETUPFLAGS=
-LXMLVERSION=$(shell cat version.txt)
+LXMLVERSION:=$(shell sed -ne '/__version__/s|.*__version__\s*=\s*"\([^"]*\)".*|\1|p' src/lxml/__init__.py)
 
-PARALLEL=$(shell $(PYTHON) -c 'import sys; print("-j7" if sys.version_info >= (3, 5) else "")' )
-PARALLEL3=$(shell $(PYTHON3) -c 'import sys; print("-j7" if sys.version_info >= (3, 5) else "")' )
-PYTHON_WITH_CYTHON=$(shell $(PYTHON)  -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
-PY3_WITH_CYTHON=$(shell $(PYTHON3) -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
-CYTHON_WITH_COVERAGE=$(shell $(PYTHON) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
-CYTHON3_WITH_COVERAGE=$(shell $(PYTHON3) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
+PARALLEL:=$(shell $(PYTHON) -c 'import sys; print("-j7" if sys.version_info >= (3, 5) else "")' )
+PARALLEL3:=$(shell $(PYTHON3) -c 'import sys; print("-j7" if sys.version_info >= (3, 5) else "")' )
+PYTHON_WITH_CYTHON:=$(shell $(PYTHON)  -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
+PY3_WITH_CYTHON:=$(shell $(PYTHON3) -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
+CYTHON_WITH_COVERAGE:=$(shell $(PYTHON) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
+CYTHON3_WITH_COVERAGE:=$(shell $(PYTHON3) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
 
-MANYLINUX_LIBXML2_VERSION=2.9.9
-MANYLINUX_LIBXSLT_VERSION=1.1.33
+MANYLINUX_LIBXML2_VERSION=2.9.10
+MANYLINUX_LIBXSLT_VERSION=1.1.34
 MANYLINUX_IMAGE_X86_64=quay.io/pypa/manylinux1_x86_64
 MANYLINUX_IMAGE_686=quay.io/pypa/manylinux1_i686

=== debian/changelog ===
lxml (4.5.0-1ubuntu0.5) focal-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - debian/patches/CVE-2021-43818-*.patch: prevent "@import"
      from re-occurring in the CSS after replacements and remove
      SVG image data URLs since they can embed script content in
      src/lxml/html/clean.py, src/html/tests/test_clean.py.
    - CVE-2021-43818

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 04 Jan 2022 09:33:10 -0300

lxml (4.5.0-1ubuntu0.3) focal-security; urgency=medium

  * SECURITY UPDATE: incorrect formaction attribute input sanitization
    - debian/patches/CVE-2021-28957.patch: add HTML-5 formaction attribute
      to defs.link_attrs in src/lxml/html/defs.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2021-28957

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 29 Mar 2021 12:04:02 -0400

lxml (4.5.0-1ubuntu0.2) focal-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - debian/patches/CVE-2020-27783-part2*.patch:
      This adds the missing part reported from upstream
      Prevent combinations of <noscript> and <style> to sneak
      JS through the HTML cleaner in src/lxml/html/clean.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2020-27783
  * Adding --with-cython to debian/rules in order to it build compile the .py
    files changed and regenerate the .c files to the binaries.

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 09 Dec 2020 21:56:41 -0300

lxml (4.5.0-1ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - Prevent combinations of <noscript> and <style> to sneak
      JS through the HTML cleaner in src/lxml/html/clean.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2020-27783

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 08 Dec 2020 13:54:35 -0300

lxml (4.5.0-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Tue, 18 Feb 2020 16:57:26 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: lxml
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9),
   dh-python,
   python-all-dev (>= 2.6.6-1~), python-all-dbg,
@@ -13,7 +14,7 @@
   python-html5lib, python3-html5lib,
   cython, cython-dbg, cython3, cython3-dbg,
 X-Python-Version: all
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: http://lxml.de/
 
 Package: python-lxml

## lxml 4.5.2

=== debian/changelog ===
lxml (4.5.2-1ubuntu0.4) groovy-security; urgency=medium

  * SECURITY UPDATE: incorrect formaction attribute input sanitization
    - debian/patches/CVE-2021-28957.patch: add HTML-5 formaction attribute
      to defs.link_attrs in src/lxml/html/defs.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2021-28957

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 29 Mar 2021 12:01:32 -0400

lxml (4.5.2-1ubuntu0.3) groovy-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - debian/patches/CVE-2020-27783-part2*.patch:
      This adds the missing part reported from upstream
      Prevent combinations of <noscript> and <style> to sneak
      JS through the HTML cleaner in src/lxml/html/clean.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2020-27783
  * Adding --with-cython to debian/rules in order to it build compile the .py
    files changed and regenerate the .c files to the binaries.

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 10 Dec 2020 12:55:54 -0300

lxml (4.5.2-1ubuntu0.2) groovy-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - debian/patches/CVE-2020-27783-part2.patch:
      This adds the missing part reported from upstream
      Prevent combinations of <noscript> and <style> to sneak
      JS through the HTML cleaner in src/lxml/html/clean.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2020-27783

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 09 Dec 2020 21:47:25 -0300

lxml (4.5.2-1ubuntu0.1) groovy-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - Prevent combinations of <noscript> and <style> to sneak
      JS through the HTML cleaner in src/lxml/html/clean.py,
      src/lxml/html/tests/test_clean.py.
    - CVE-2020-27783

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 08 Dec 2020 13:56:06 -0300

lxml (4.5.2-1) unstable; urgency=medium

  * New upstream version.
  * Stop building python2 packages.
  * Bump debhelper version.

 -- Matthias Klose <doko@debian.org>  Fri, 17 Jul 2020 11:05:52 +0200

=== debian/control ===
--- 
+++ 
@@ -3,52 +3,17 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
   dh-python,
-  python-all-dev (>= 2.6.6-1~), python-all-dbg,
   python3-all-dev (>= 3.3.3), python3-all-dbg,
-  python-pyrex (>= 0.9.4.1),
   libxml2-dev, libxslt1-dev, zlib1g-dev,
-  python-setuptools, python3-setuptools (>= 0.6.29),
-  python-bs4, python3-bs4,
-  python-html5lib, python3-html5lib,
-  cython, cython-dbg, cython3, cython3-dbg,
+  python3-setuptools (>= 0.6.29),
+  python3-bs4,
+  python3-html5lib,
+  cython3, cython3-dbg,
 X-Python-Version: all
 Standards-Version: 4.5.0
 Homepage: http://lxml.de/
-
-Package: python-lxml
-Architecture: any
-Multi-Arch: same
-Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
-Provides: ${python:Provides}
-Recommends: python-bs4, python-html5lib
-Suggests: python-lxml-dbg, python-lxml-doc
-Description: pythonic binding for the libxml2 and libxslt libraries
- lxml is a new Python binding for libxml2 and libxslt, completely
- independent from existing Python bindings. Its aim:
- .
-   * Pythonic API.
-   * Documented.
-   * Use Python unicode strings in API.
-   * Safe (no segfaults).
-   * No manual memory management!
- .
- lxml aims to provide a Pythonic API by following as much as possible
- the ElementTree API, trying to avoid inventing too many new APIs,
- or the user's having to learn new things -- XML is complicated enough.
-
-Package: python-lxml-dbg
-Priority: optional
-Section: debug
-Architecture: any
-Multi-Arch: same
-Depends: python-lxml (= ${binary:Version}), python2-dbg, ${shlibs:Depends}, ${misc:Depends}
-Description: pythonic binding for the libxml2 and libxslt libraries (debug extension)
- lxml is a new Python binding for libxml2 and libxslt, completely
- independent from existing Python bindings.
- .
- This package contains the extension built for the Python debug interpreter.
 
 Package: python3-lxml
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,6 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
-
-PYVERS	:= $(shell pyversions -vs)
-PYVER	:= $(shell pyversions -vd)
 
 PY3VERS	:= $(shell py3versions -vs)
 PY3VER	:= $(shell py3versions -vd)
@@ -21,17 +18,9 @@
 
 build-arch: build
 build-indep: build
-build: build-stamp build3-stamp
-build-stamp: $(PYVERS:%=build-python%) $(PYVERS:%=dbg-build-python%) $(PYVERS:%=check-python%)
-	touch $@
-build-python%: prebuild
-	python$* setup.py build --with-cython
-	touch $@
-dbg-build-python%: prebuild
-	python$*-dbg setup.py build --with-cython
-	touch $@
+build: build3-stamp
 
-build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%) $(PY3VERS:%=check-python%)
+build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%)
 	touch $@
 build3-python%: prebuild
 	python$* setup.py build --with-cython
@@ -40,17 +29,10 @@
 	python$*-dbg setup.py build --with-cython
 	touch $@
 
-check-python%:
-	python$* setup.py build_ext -i
-	-python$* test.py -vv
-	#python$*-dbg setup.py build_ext -i
-	#-python$*-dbg test.py -vv
-	touch $@
-
 clean:
 	dh_testdir
 	dh_testroot
-	rm -f build*-stamp build*-python* dbg-build*-python* prebuild-stamp check-python*
+	rm -f build*-stamp build*-python* dbg-build*-python* prebuild-stamp
 	rm -rf build dist __pycache__
 #	rm -f src/lxml/lxml.etree_api.h src/lxml/lxml.etree.c \
 #	      src/lxml/lxml.etree.h src/lxml/lxml.objectify.c
@@ -60,7 +42,7 @@
 	rm -f src/lxml/lxml-version.h
 	dh_clean 
 
-install: build install-prereq $(PYVERS:%=install-python%) $(PYVERS:%=dbg-install-python%) $(PY3VERS:%=install3-python%) $(PY3VERS:%=dbg-install3-python%)
+install: build install-prereq $(PY3VERS:%=install3-python%) $(PY3VERS:%=dbg-install3-python%)
 	-find debian -name '*.py[co]' | xargs rm -f
 	-find debian -name __pycache__ | xargs rm -rf
 	rm -rf debian/python*-lxml/usr/lib/python
@@ -69,20 +51,6 @@
 	dh_testdir
 	dh_testroot
 	dh_prep
-
-install-python%:
-	mkdir -p debian/python-lxml/usr/bin
-	mkdir -p debian/python-lxml/$(call py_libdir, $*)
-	python$* setup.py install \
-		--root=$(CURDIR)/debian/python-lxml --install-layout=deb
-
-dbg-install-python%:
-	mkdir -p debian/python-lxml/usr/bin
-	mkdir -p debian/python-lxml-dbg/$(call py_libdir, $*)
-	python$*-dbg setup.py install \
-		--root=$(CURDIR)/debian/python-lxml-dbg --install-layout=deb
-	find debian/python-*-dbg ! -type d ! -name '*.so' | xargs rm -f
-	find debian/python-*-dbg -depth -empty -exec rmdir {} \;
 
 install3-python%:
 	mkdir -p debian/python3-lxml/usr/bin
@@ -124,11 +92,7 @@
 	dh_installchangelogs -a CHANGES.txt
 	dh_installdocs -a CREDITS.txt README.rst TODO.txt
 	dh_installexamples -a samples/*
-	dh_python2 -a
 	dh_python3 -a
-	dh_strip -ppython-lxml --dbg-package=python-lxml-dbg
-	rm -rf debian/python-lxml-dbg/usr/share/doc/python-lxml-dbg
-	ln -s python-lxml debian/python-lxml-dbg/usr/share/doc/python-lxml-dbg
 	dh_strip -ppython3-lxml --dbg-package=python3-lxml-dbg
 	rm -rf debian/python3-lxml-dbg/usr/share/doc/python3-lxml-dbg
 	ln -s python3-lxml debian/python3-lxml-dbg/usr/share/doc/python3-lxml-dbg

## lxml 4.6.1

=== debian/changelog ===
lxml (4.6.1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Tille <tille@debian.org>  Wed, 11 Nov 2020 14:49:46 +0100

lxml (4.6.1-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 22 Oct 2020 18:02:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lxml
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 10),
   dh-python,
   python3-all-dev (>= 3.3.3), python3-all-dbg,
@@ -11,6 +10,7 @@
   python3-bs4,
   python3-html5lib,
   cython3, cython3-dbg,
+#  python3-sphinx-autoapi,
 X-Python-Version: all
 Standards-Version: 4.5.0
 Homepage: http://lxml.de/

## lxml 4.6.2

=== debian/changelog ===
lxml (4.6.2-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
    Closes: #974684
  * Do not Build-Depend python3-sphinx-autoapi

 -- Andreas Tille <tille@debian.org>  Tue, 15 Dec 2020 09:40:41 +0100

lxml (4.6.2-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Mon, 07 Dec 2020 18:22:48 +0100

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,8 @@
   python3-bs4,
   python3-html5lib,
   cython3, cython3-dbg,
-#  python3-sphinx-autoapi,
 X-Python-Version: all
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: http://lxml.de/
 
 Package: python3-lxml

=== debian/rules ===
--- 
+++ 
@@ -23,10 +23,10 @@
 build3-stamp: $(PY3VERS:%=build3-python%) $(PY3VERS:%=dbg-build3-python%)
 	touch $@
 build3-python%: prebuild
-	python$* setup.py build --with-cython
+	python$* setup.py build
 	touch $@
 dbg-build3-python%: prebuild
-	python$*-dbg setup.py build --with-cython
+	python$*-dbg setup.py build
 	touch $@
 
 clean:

## lxml 4.6.3

=== debian/changelog ===
lxml (4.6.3-1ubuntu0.2~cloud0) focal-wallaby; urgency=medium

  * New update for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Wed, 12 Jan 2022 14:18:50 +0000

lxml (4.6.3-1ubuntu0.2) hirsute-security; urgency=medium

  * SECURITY UPDATE: XSS vulnerability
    - debian/patches/CVE-2021-43818-*.patch: prevent "@import"
      from re-occurring in the CSS after replacements and remove
      SVG image data URLs since they can embed script content in
      src/lxml/html/clean.py, src/html/tests/test_clean.py.
    - CVE-2021-43818

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 04 Jan 2022 09:22:22 -0300

lxml (4.6.3-1) unstable; urgency=high

  * New upstream version.
    - A vulnerability (CVE-2021-28957) was discovered in the HTML Cleaner,
      which allowed JavaScript to pass through. The cleaner now removes the
      HTML5 formaction attribute. 

 -- Matthias Klose <doko@debian.org>  Mon, 22 Mar 2021 14:31:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: lxml
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 10),
   dh-python,
   python3-all-dev (>= 3.3.3), python3-all-dbg,
@@ -10,6 +11,7 @@
   python3-bs4,
   python3-html5lib,
   cython3, cython3-dbg,
+  python3-sphinx-autoapi,
 X-Python-Version: all
 Standards-Version: 4.5.1
 Homepage: http://lxml.de/

## lxml 4.6.3+dfsg

=== Makefile ===
PYTHON?=python
PYTHON3?=python3
TESTFLAGS=-p -v
TESTOPTS=
SETUPFLAGS=
LXMLVERSION:=$(shell sed -ne '/__version__/s|.*__version__\s*=\s*"\([^"]*\)".*|\1|p' src/lxml/__init__.py)

PARALLEL?=$(shell $(PYTHON) -c 'import sys; print("-j7" if sys.version_info >= (3, 5) else "")' )
PARALLEL3?=$(shell $(PYTHON3) -c 'import sys; print("-j7" if sys.version_info >= (3, 5) else "")' )
PYTHON_WITH_CYTHON?=$(shell $(PYTHON)  -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
PY3_WITH_CYTHON?=$(shell $(PYTHON3) -c 'import Cython.Build.Dependencies' >/dev/null 2>/dev/null && echo " --with-cython" || true)
CYTHON_WITH_COVERAGE?=$(shell $(PYTHON) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)
CYTHON3_WITH_COVERAGE?=$(shell $(PYTHON3) -c 'import Cython.Coverage; import sys; assert not hasattr(sys, "pypy_version_info")' >/dev/null 2>/dev/null && echo " --coverage" || true)

MANYLINUX_LIBXML2_VERSION=2.9.10
MANYLINUX_LIBXSLT_VERSION=1.1.34
MANYLINUX_CFLAGS=-O3 -g1 -pipe -fPIC -flto
MANYLINUX_LDFLAGS=-flto
MANYLINUX_IMAGE_X86_64=quay.io/pypa/manylinux1_x86_64
MANYLINUX_IMAGE_686=quay.io/pypa/manylinux1_i686
MANYLINUX_IMAGE_AARCH64=quay.io/pypa/manylinux2014_aarch64

AARCH64_ENV=-e AR="/opt/rh/devtoolset-9/root/usr/bin/gcc-ar" \
		-e NM="/opt/rh/devtoolset-9/root/usr/bin/gcc-nm" \
		-e RANLIB="/opt/rh/devtoolset-9/root/usr/bin/gcc-ranlib"

.PHONY: all inplace inplace3 rebuild-sdist sdist build require-cython wheel_manylinux wheel

all: inplace

# Build in-place
inplace:
	$(PYTHON) setup.py $(SETUPFLAGS) build_ext -i $(PYTHON_WITH_CYTHON) --warnings $(subst --,--with-,$(CYTHON_WITH_COVERAGE)) $(PARALLEL)

inplace3:
	$(PYTHON3) setup.py $(SETUPFLAGS) build_ext -i $(PY3_WITH_CYTHON) --warnings $(subst --,--with-,$(CYTHON3_WITH_COVERAGE)) $(PARALLEL3)

rebuild-sdist: require-cython
	rm -f dist/lxml-$(LXMLVERSION).tar.gz
	find src -name '*.c' -exec rm -f {} \;
	$(MAKE) dist/lxml-$(LXMLVERSION).tar.gz

dist/lxml-$(LXMLVERSION).tar.gz:
	$(PYTHON) setup.py $(SETUPFLAGS) sdist $(PYTHON_WITH_CYTHON)

sdist: dist/lxml-$(LXMLVERSION).tar.gz

build:
	$(PYTHON) setup.py $(SETUPFLAGS) build $(PYTHON_WITH_CYTHON)

require-cython:
	@[ -n "$(PYTHON_WITH_CYTHON)" ] || { \
	    echo "NOTE: missing Cython - please use this command to install it: $(PYTHON) -m pip install Cython"; false; }

qemu-user-static:
	docker run --rm --privileged multiarch/qemu-user-static --reset -p yes

wheel_manylinux: wheel_manylinux64 wheel_manylinux32 wheel_manylinuxaarch64
wheel_manylinuxaarch64: qemu-user-static

wheel_manylinux32 wheel_manylinux64 wheel_manylinuxaarch64: dist/lxml-$(LXMLVERSION).tar.gz
	time docker run --rm -t \
		-v $(shell pwd):/io \
		$(if $(patsubst %aarch64,,$@),,$(AARCH64_ENV)) \
		-e CFLAGS="$(MANYLINUX_CFLAGS) $(if $(patsubst %aarch64,,$@),-march=core2,-march=armv8-a -mtune=cortex-a72)" \
		-e LDFLAGS="$(MANYLINUX_LDFLAGS)" \
		-e LIBXML2_VERSION="$(MANYLINUX_LIBXML2_VERSION)" \
		-e LIBXSLT_VERSION="$(MANYLINUX_LIBXSLT_VERSION)" \
		-e WHEELHOUSE=wheelhouse_$(subst wheel_,,$@) \
		$(if $(filter $@,wheel_manylinuxaarch64),$(MANYLINUX_IMAGE_AARCH64),$(if $(patsubst %32,,$@),$(MANYLINUX_IMAGE_X86_64),$(MANYLINUX_IMAGE_686))) \
		bash /io/tools/manylinux/build-wheels.sh /io/$<

wheel:
	$(PYTHON) setup.py $(SETUPFLAGS) bdist_wheel $(PYTHON_WITH_CYTHON)

wheel_static:
	$(PYTHON) setup.py $(SETUPFLAGS) bdist_wheel $(PYTHON_WITH_CYTHON) --static-deps

test_build: build
	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS)

test_inplace: inplace
	$(PYTHON) test.py $(TESTFLAGS) $(TESTOPTS) $(CYTHON_WITH_COVERAGE)

test_inplace3: inplace3
	$(PYTHON3) test.py $(TESTFLAGS) $(TESTOPTS) $(CYTHON3_WITH_COVERAGE)

valgrind_test_inplace: inplace
	valgrind --tool=memcheck --leak-check=full --num-callers=30 --suppressions=valgrind-python.supp \
		$(PYTHON) test.py

gdb_test_inplace: inplace
	@echo "file $(PYTHON)\nrun test.py" > .gdb.command
	gdb -x .gdb.command -d src -d src/lxml

bench_inplace: inplace
	$(PYTHON) benchmark/bench_etree.py -i
	$(PYTHON) benchmark/bench_xpath.py -i
	$(PYTHON) benchmark/bench_xslt.py -i
	$(PYTHON) benchmark/bench_objectify.py -i

ftest_build: build
	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)

ftest_inplace: inplace
	$(PYTHON) test.py -f $(TESTFLAGS) $(TESTOPTS)

apidoc: apidocclean
	@[ -x "`which sphinx-apidoc`" ] \
		&& (echo "Generating API docs ..." && \
			PYTHONPATH=src:$(PYTHONPATH) sphinx-apidoc -e -P -T -o doc/api src/lxml \
				"*includes" "*tests" "*pyclasslookup.py" "*usedoctest.py" "*html/_html5builder.py" \
				"*.so" "*.pyd") \
		|| (echo "not generating Sphinx autodoc API rst files")

apihtml: apidoc inplace3
	@[ -x "`which sphinx-build`" ] \
		&& (echo "Generating API docs ..." && \
			make -C doc/api html) \
		|| (echo "not generating Sphinx autodoc API documentation")

website: inplace3 docclean
	PYTHONPATH=src:$(PYTHONPATH) $(PYTHON3) doc/mkhtml.py doc/html . ${LXMLVERSION}

html: apihtml website s5

s5:
	$(MAKE) -C doc/s5 slides

apipdf: apidoc inplace3
	rm -fr doc/api/_build
	@[ -x "`which sphinx-build`" ] \
		&& (echo "Generating API PDF docs ..." && \
			make -C doc/api latexpdf) \
		|| (echo "not generating Sphinx autodoc API PDF documentation")

pdf: apipdf pdfclean
	$(PYTHON) doc/mklatex.py doc/pdf . ${LXMLVERSION}
	(cd doc/pdf && pdflatex lxmldoc.tex \
		    && pdflatex lxmldoc.tex \
		    && pdflatex lxmldoc.tex)
	@cp doc/pdf/lxmldoc.pdf doc/pdf/lxmldoc-${LXMLVERSION}.pdf
	@echo "PDF available as doc/pdf/lxmldoc-${LXMLVERSION}.pdf"

# Two pdflatex runs are needed to build the correct Table of contents.

test: test_inplace

test3: test_inplace3

valtest: valgrind_test_inplace

gdbtest: gdb_test_inplace

bench: bench_inplace

ftest: ftest_inplace

clean:
	find . \( -name '*.o' -o -name '*.so' -o -name '*.py[cod]' -o -name '*.dll' \) -exec rm -f {} \;
	rm -rf build

docclean:
	$(MAKE) -C doc/s5 clean
	rm -f doc/html/*.html

pdfclean:
	rm -fr doc/pdf

apidocclean:
	rm -fr doc/html/api
	rm -f doc/api/lxml*.rst
	rm -fr doc/api/_build

realclean: clean docclean apidocclean
	find src -name '*.c' -exec rm -f {} \;
	rm -f TAGS
	$(PYTHON) setup.py clean -a --without-cython

=== debian/changelog ===
lxml (4.6.3+dfsg-0.1+deb11u1) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Cleaner: Prevent "@import" from re-occurring in the CSS after
    replacements, e.g. "@@importimport" (CVE-2021-43818) (Closes: #1001885)
  * Cleaner: Remove SVG image data URLs since they can embed script content
    (CVE-2021-43818) (Closes: #1001885)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 08 Jan 2022 15:06:02 +0100

lxml (4.6.3+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * Repack upstream to drop non-free and unused file (Closes: #988717)
  * Build and ship documentation (Closes: #799334)

 -- Paul Gevers <elbrus@debian.org>  Sat, 26 Jun 2021 19:40:37 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lxml
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 10),
   dh-python,
   python3-all-dev (>= 3.3.3), python3-all-dbg,
@@ -10,6 +9,7 @@
   python3-setuptools (>= 0.6.29),
   python3-bs4,
   python3-html5lib,
+  python3-lxml <!nodoc>,
   cython3, cython3-dbg,
   python3-sphinx-autoapi,
 X-Python-Version: all

=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,9 @@
 	touch $@
 build3-python%: prebuild
 	python$* setup.py build
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+	python$* doc/mkhtml.py doc/html . $(UPSTREAMVER)
+endif
 	touch $@
 dbg-build3-python%: prebuild
 	python$*-dbg setup.py build
